# Latest commit 883bac7 on Jul 26 2017
# git clone https://github.com/DIGImend/digimend-kernel-drivers.git
# now in DIGImend-Tablets.pdf

%global		pname	digimend

Name:		dkms-%{pname}
Version:	10.0
Release:	%mkrel 7
Source0:	%{pname}-%{version}.tar.xz
Source1:	DIGImend-Tablets-2019.pdf
#####pclos-digimend-conf.patch
Patch0:		pclos-digimend-10-conf.patch
Patch1:		digimend-10.0-makefile-new.patch
#Patch2:		digimend-huion-hs610-2020-04.patch
# #define USB_DEVICE_ID_HUION_TABLET2019	0x006d  -now-as-
# #define USB_DEVICE_ID_HUION_TABLET2	0x006d
##Patch2:		digimend-huion-hs610.patch
###Patch1:		pclos-digimend-dkms-conf.patch
#Patch2:		pclos-digimend-7-makefile.patch
#Patch3:		pclos-digimend-7-HID-QUIRK-NO-EMPTY-INPUT.patch
#Patch4:		pclos-digimend-8-makefile.patch
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/DIGImend/digimend-kernel-drivers
Summary:	dkms drivers for a collection of graphics tablet
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name}-%{version}
Requires(preun,post): dkms
Suggests:	uclogic-tools
Obsoletes:	%{name} <= %{version} 

%description -n %{name}
Please restart your Xsession(logout & login) or reboot after installation.

rebuild add support for HS64

also HS610Pro should works now 

Important changes since v8 release:

-Add support for XP-Pen G640.
-Fix support for Ugee M540.
-Fix support for Huion WH1409.
-Add installation of X.org configuration, which requests the Wacom driver
-to handle all known compatible tablets, by default.
-Any X.org configuration for the same tablets in /etc would still override this.
-Move installed hid-rebind to /lib/udev

Important changes since v7 release:

-Rework the UC-Logic driver to support the new Huion tablets, while keeping
-support of all the other tablets. This brings support for at least the following
-Huion tablets: H430P, H640P, H950P, and Huion New 1060 Plus.
-Thank you to Björn Paetzel and Andrey Zabolotnyi for initial
-implementation and figuring out proximity detection, to Huion for tablet
-samples and financing the work, and to all the users for testing and bug
-reports!
-Add support for Ugee G5.
-Thank you for the tablet sample and financing, Neoblast Inc.!
-Add support for XP-Pen Deco 01.
-Thank you for the initial implementation and testing, kodkuce!
-Add "dkms_install" and "dkms_uninstall" targets to the Makefile.
-These should be used now for installing and uninstalling the
-driver on all non-Debian based distros, as well as for installing and
-uninstalling the development versions of the driver. Use "install" and
-"uninstall" only if those didn't work (and report your issue).
-Add "dist" target to the Makefile for building tarballs for external
-packaging. Thank you, Hai Hoang Dang!
-Various documentation fixes and improvements.

on Release v7
An out-of-tree kernel driver package from DIGImend.
See also the list of all tablets DIGImend project has information about,
in doc's of the package.
The tablets there are grouped by their OEMs. A tablet's "original model" name
(if any) is the name used by the OEM or reported by the tablet itself,
in its device descriptor. For the tablets with unknown name,
the "original model" is specified as "PID" followed by
the four-digit hexadecimal product ID.
Fixes UC-Logic tablets not working after a suspend/resume cycle.
- Add support for KYE EasyPen M406XE. Thank you, Andrey Alekseenko!
- Add support for XP-Pen G540. Thank you, slawkis!
- Add support for Ugee EX07(S)/XP-Pen star05.
- Add support for Ugee M540, which reuses VID:PID of UC-Logic WP5540U.
- Add support for Ugee 2150. Thank you, Pierre-Marc Jobin!
- Add support for ViewSonic PD1011, aka Signotec Delta PD 10.1.

Please be aware that if you have Secure Boot enabled, you will need to either
disable it, or to sign the installed drivers, before they will be permitted to
load.

Read more on /usr/share/doc/dkms-digimend/README.md !

%prep
%setup -qn %{pname}-%{version}

%apply_patches

find -type f -exec chmod 0644 {} \;



%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME=%{pname}
PACKAGE_VERSION=%{version}-%{release}
BUILT_MODULE_NAME[0]="hid-kye"
BUILT_MODULE_NAME[1]="hid-uclogic"
BUILT_MODULE_NAME[2]="hid-polostar"
BUILT_MODULE_NAME[3]="hid-viewsonic"
BUILT_MODULE_LOCATION[0]="./"
BUILT_MODULE_LOCATION[1]="./"
BUILT_MODULE_LOCATION[2]="./"
BUILT_MODULE_LOCATION[3]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/digimend"
DEST_MODULE_LOCATION[1]="/kernel/3rdparty/digimend"
DEST_MODULE_LOCATION[2]="/kernel/3rdparty/digimend"
DEST_MODULE_LOCATION[3]="/kernel/3rdparty/digimend"
MAKE[0]="'make' SKIP_STACK_VALIDATION=1 all"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

%__install -dm744 %{buildroot}%{_docdir}/dkms-digimend
%__install -dm744 %{buildroot}/lib/udev/rules.d
%__install -dm744 %{buildroot}/etc/depmod.d
%__install -dm744 %{buildroot}/etc/X11/xorg.conf.d
%__install -m644 %{S:1} %{buildroot}%{_docdir}/dkms-digimend/
%__install -m644 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/udev.rules %{buildroot}/lib/udev/rules.d/90-digimend.rules
%__install -m755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/hid-rebind %{buildroot}/lib/udev/hid-rebind
%__install -m644 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/depmod.conf %{buildroot}/etc/depmod.d/digimend.conf
%__install -m644 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/xorg.conf %{buildroot}/etc/X11/xorg.conf.d/50-digimend.conf

# add 52-tablet.conf to work also for HS610PRO
%__cat <<EOF > %{buildroot}/etc/X11/xorg.conf.d/52-tablet.conf
Section "InputClass"
Identifier "Huion on wacom"
# MatchIsTablet "on"
MatchProduct "HUION"
MatchDevicePath "/dev/input/event*"
Driver "wacom"
EndSection
EOF


%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}


%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all


%clean
%__rm -rf %{buildroot}

%files -n %{name}
%defattr(-,root,root)
%doc COPYING README.md
%{_docdir}/%{name}/DIGImend-Tablets-2019.pdf
%{_usrsrc}/%{pname}-%{version}-%{release}/*
%config(noreplace) /lib/udev/rules.d/90-digimend.rules
/lib/udev/hid-rebind
%config(noreplace) /etc/depmod.d/digimend.conf
%config(noreplace) /etc/X11/xorg.conf.d/52-tablet.conf
%config(noreplace) /etc/X11/xorg.conf.d/50-digimend.conf

%changelog
* Tue Apr 14 2020 onkelho <oh.quait at gmail.com> - 10.0-7pclos2020
- rebuild - Revert "uclogic: Remove Wacom-mimicking fake pad reports"
- uclogic: Fix uclogic_params_huion_init() docs
- uclogic: Replace pen_frame_flag with subreport_list
- uclogic: Switch to matching subreport bytes
- uclogic: Specify total report size to buttonpad macro
- uclogic: Use "frame" instead of "buttonpad"
- uclogic: Put version first in rdesc namespace
- uclogic: Use different constants for frame report IDs
- uclogic: Actually re-route the changed report ID
- uclogic: Support multiple frame input devices
- uclogic: Add support for touch ring reports
- uclogic: Support custom device suffix for frames
- uclogic: Support two pen subreports
- uclogic: Support two frame devices
- uclogic: Define report IDs before their descriptors
- uclogic: Support touch ring reports
- uclogic: Say "touch ring" not "dial"
- uclogic: Allow three frame parameter sets
- uclogic: Compress params format string
- uclogic: Add support for bitmap dials
- uclogic: Add support for Huion Q620M
- uclogic: Reduce indent for params format str/args
- uclogic: Pass keyboard reports as is
- uclogic: Clarify pen subreport list description
- uclogic: Clarify params desc_size description
- uclogic: Clarify pen/frame desc_ptr description
- uclogic: Support disabling pen usage
- uclogic: Disable pen usage for Huion keyboard interfaces
- uclogic: Move param printing to a function
- uclogic: Return raw parameters from v2 pen init
- uclogic: Do not focus on touch ring only
- uclogic: Clarify validity of touch parameters
- uclogic: Always shift touch reports to zero
- uclogic: Differentiate touch ring and touch strip 

* Fri Jan 17 2020 onkelho <oh.quait at gmail.com> - 10.0-6pclos2020
- rebuild - uclogic: Remove pen usage masking
- uclogic: Remove Wacom-mimicking fake pad reports 
- uclogic: Rename Huion HS64 PID to Huion Tablet 2
- add HS64

* Thu Aug 08 2019 onkelho <oh.quait at gmail.com> - 10.0-5pclos2019
- fix doublequoats in 52-tablet.conf

* Thu Aug 08 2019 onkelho <oh.quait at gmail.com> - 10.0-4pclos2019
- add patch2 digimend-huion-hs610.patch
- suggests to install uclogic-tools, for reporting/requests on driver-build 
- move 50-digimend.conf to /etc/X11/xorg.conf.d/ such wacom 
- add 52-tablet.conf
- fix depmod.conf 3rdparty/digimend to -
- - kernel/3rdparty/digimend in pclos-digimend-10-conf.patch
- in digimend-0.10.0-makefile.patch /etc/X11/xorg.conf.d

* Tue Aug 06 2019 onkelho <oh.quait at gmail.com> - 10.0-2pclos2019
- Updating f7edb78..8b228a7
- updates in: hid-ids.h hid-uclogic-core.c hid-uclogic-params.c xorg.conf 

* Tue Mar 26 2019 onkelho <oh.quait at gmail.com> 10.0-1pclos2019
- rebuild fix remove rules and confs by remove preinstalled
- new packageversion (not rel jet) = release of dkms-package
- 37 commits since releasing v9
- uclogic: Support Huion tilt reporting

* Sat Nov 24 2018 onkelho <oh.quait at gmail.com> 9.0-5pclos2018
- rebuild

* Wed Nov 14 2018 onkelho <oh.quait at gmail.com> 9.0-4pclos2018
- rebuild

* Wed Nov 14 2018 onkelho <oh.quait at gmail.com> 9.0-3pclos2018
- rebuild fix compress and depmod.conf-+-patch
- + makefile mkdir

* Fri Nov 09 2018 onkelho <oh.quait at gmail.com> 9.0-1pclos2018
- new version pre-rel + -latest Commits on Nov 03, 2018 @spbnick spbnick 
-   - Add installation of X.org configuration ea507e2

* Sun Aug 19 2018 onkelho <oh.quait at gmail.com> 8.0-1pclos2018
- new version release

* Mon Jun 18 2018 onkelho <oh.quait at gmail.com> 7.0-4pclos2018
- rebuild add patch3:
- - uclogic: Handle kernels w/o HID_QUIRK_NO_EMPTY_INPUT
  - Handle building without HID_QUIRK_NO_EMPTY_INPUT, which is removed from
  - newer kernels, where it's behavior is the default.

* Fri May 04 2018 onkelho <oh.quait at gmail.com> 7.0-3pclos2018
- rebuild --v7-8-g2fb8ad4

* Sat Feb 03 2018 onkelho <oh.quait at gmail.com> 7.0-1pclos2018
- update
- Add support for building with v4.4 and newer kernels.
- Add support for KYE PenSketch M912. Thank you, Milan Plzik!
- Fix possible buffer overflow in hid-uclogic.c. Thank you, Dan Carpenter!
- Ensure hid-rebind looks for programs in /sbin and /usr/sbin. Fixes #49.
- Re-enable tablet on resume.
- Fixes UC-Logic tablets not working after a suspend/resume cycle.
- Add support for KYE EasyPen M406XE. Thank you, Andrey Alekseenko!
- Add support for XP-Pen G540. Thank you, slawkis!
- Add support for Ugee EX07(S)/XP-Pen star05.
- Add support for Ugee M540, which reuses VID:PID of UC-Logic WP5540U.
- Add support for Ugee 2150. Thank you, Pierre-Marc Jobin!
- Add support for ViewSonic PD1011, aka Signotec Delta PD 10.1.
- Fix several issues with the Debian package. Thank you, Martin Owens!

* Sat Sep 30 2017 onkelho <oh.quait at gmail.com> 6.0-1pclos2017
- rebuild to use patches of gited sources

* Fri Sep 29 2017 onkelho <oh.quait at gmail.com> 6-1pclos2017
- initial package

